<?
/*
 * string dateFr(string format, int timestamp)
 * string dateFr(string format)
 *
 * Retourne une date sous forme d'une chane, au format donn par la chane format.
 * La date est fournie sous la forme d'un timestamp. Par dfaut, la date courante est utilise.
 * Les caractres suivants sont utiliss pour spcifier le format :
 *
 *  D - Jour de la semaine, en trois lettres : par exemple "Ven" (pour Vendredi)
 *  l - Jour de la semaine, textuel, version longue; ex: Vendredi
 *
 *  j - Jour du mois sans les zros initiaux: "1"  "31"
 *  d - Jour du mois, sur deux chiffres (ventuellement avec un zros) : "01"  "31"
 *
 *  n - Mois sans les zros initiaux; i.e. "1"  "12"
 *  m - Mois; i.e. "01"  "12"
 *  M - Mois, en trois lettres : par exemple "Jan" (pour Janvier)
 *  F - Mois, textuel, version longue; ex: Janvier
 *
 *  y - Anne, 2 chiffres; i.e. "99"
 *  Y - Anne, 4 chiffres; i.e. "1999"
 *
 *  g - Heure, au format 12h sans les zros initiaux, "1"  "12"
 *  e - Heure, au format 12h, "01"  "12"
 *  G - Heure, au format 24h sans les zros initiaux, "0"  "23"
 *  E - heure, au format 24h, "00"  "23"
 *
 *  i - Minutes; "00"  "59"
 *
 *  s - Secondes; i.e. "00"  "59"
 *
 */

function dateFr($format, $date= '') {
  $dateRetour = "";
  if ($date=='')
    $date = mktime(date('H'), date('i'), date('s'), date('m'), date('d'), date('Y'), -1);
  $TJour = array("Dimanche","Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi");
  $TMois = array("Janvier","Fevrier","Mars","Avril","Mai","Juin","Juillet","Aout","Septembre","Octobre","Novembre","Dcembre");
  
  for($i=0; $i<strlen($format); $i++) {
	$char = substr($format, $i, 1);
	switch($char) {
		case 'd' : $dateRetour .= date('d', $date); break;
		case 'D' : $dateRetour .= substr($TJour[date('w', $date)],0,3); break;
		case 'F' : $dateRetour .= $TMois[date('n', $date)-1]; break;
		case 'e' : $dateRetour .= date('h', $date); break;
		case 'E' : $dateRetour .= date('H', $date); break;
		case 'g' : $dateRetour .= date('g', $date); break;
		case 'G' : $dateRetour .= date('G', $date); break;
		case 'i' : $dateRetour .= date('i', $date); break;
		case 'j' : $dateRetour .= date('j', $date); break;
		case 'l' : $dateRetour .= $TJour[date('w', $date)]; break;
		case 'm' : $dateRetour .= date('m', $date); break;
		case 'n' : $dateRetour .= date('n', $date); break;
		case 'M' : $dateRetour .= substr($TMois[date('n', $date)-1],0,3); break;
		case 's' : $dateRetour .= date('s', $date); break;
		case 'Y' : $dateRetour .= date('Y', $date); break;
		case 'y' : $dateRetour .= date('y', $date); break;
		default : $dateRetour .= $char;
	}
  }
  return($dateRetour);
}

/*
 * int mkdate(String date)
 *
 * Retourne une date sous forme d'un entier timestamp  partir d'une chaine de la forme "AAAAMMJJ".
 */

function mkDate($chaineDate) {
  return(mktime(0, 0, 0, substr($chaineDate,4,2), substr($chaineDate,6,2), substr($chaineDate,0,4), -1));
}

/*
 * int mkDateHeure(String date)
 *
 * Retourne une date sous forme d'un entier timestamp  partir d'une chaine de la forme "AAAAMMJJHHMMSS".
 */

function mkDateHeure($chaineDate) {
  return(mktime(substr($chaineDate,8,2), substr($chaineDate,10,2), substr($chaineDate,12,2), substr($chaineDate,4,2), substr($chaineDate,6,2), substr($chaineDate,0,4), -1));
}

/*
 * int nbJour(String mois)
 * int nbJour(String mois, String anne)
 *
 * Retourne le nombre de jour du mois pass en paramtre
 * mois compris entre 1 et 12
 *
 */

function nbJour($Mois, $Annee) {
  return(date("t", mktime(0,0,0,$Mois,1,$Annee)));
}

/*
 * String mois(String date)
 *
 * Retourne le numero de mois "MM" d'une date de la forme "AAAAMMJJ"
 */

function mois($date) {
  return(substr($date,4,2));
}

/*
 * String jour(String date)
 *
 * Retourne le numero du jour "JJ" d'une date de la forme "AAAAMMJJ"
 */

function jour($date) {
  return(substr($date,6,2));
}
?>